#ifndef EMETER_H
#define EMETER_H



// gwoli czytelności
#define PIN_INPUT_OHM 35
#define PIN_INPUT_VOLT 34
#define PIN_INPUT_ACC 36
#define PIN_INPUT_HIGH 39

#ifdef __ESP_ADC_CAL_H__
#define ADC1_OHM ADC1_CHANNEL_7
#define ADC1_VOLT ADC1_CHANNEL_6
#define ADC1_ACC ADC1_CHANNEL_0
#define ADC1_HIGH ADC1_CHANNEL_3

#define ADC_OHM ADC_CHANNEL_7
#define ADC_VOLT ADC_CHANNEL_6
#define ADC_ACC ADC_CHANNEL_0
#define ADC_HIGH ADC_CHANNEL_3
#endif

#define PIN_OHM_0 21
#define PIN_OHM_1 19
#define PIN_OHM_2 18




#define PIN_RL1A 25
#define PIN_RL1B 26
#define PIN_RL2A 27
#define PIN_RL2B 13

#define PIN_AUDIO 12

#define I2C_SCL 16
#define I2C_SDA 17
#define I2C_RST 4

#define PIN_KEY_ENCODER 22
#define PIN_ENCODER_A 33
#define PIN_ENCODER_B 23

#define PIN_LED 2


enum {
    SPEMD_NONE=0,
    SPEMD_KLATT,
    SPEMD_SPEECHD,
    SPEMD_APP,
    SPEMD_RAW,
    SPEMD_MAX
    };

extern void initDisplay(void);
extern void doDisplay(void);
extern void setDisplayBig(int mode, const char *str = nullptr);
extern int thisSpkMode, oldSpkMode,maxSpkMode,speechMode;
extern void initSpkDispModes(void);
struct spkdisps {
    int spkmode;
    const char *modename;
};
extern struct spkdisps spkdisplay[];
extern int dpMOD;


extern int mV_Vcc, mV_LiIon;

enum {
    MMOD_SELECT = 0,
    MMOD_OHM_TYP6, // typoszereg, jednorazowy odczyt przy zmianie wartości
    MMOD_OHM_TYP12, // typoszereg, jednorazowy odczyt przy zmianie wartości
    MMOD_OHM_STILL, // rezystancja, odczyt co ileś tam milisekund - do ustawienia
    MMOD_SHORT, // przejście, brak odczytu, sygnalizacja dźwiękowa
    MMOD_DIODE, // napięcie przewodzenia diody, odczyt przy zmianie wartości, próg?
    MMOD_VOLTAGE, // napięcie, odczyt co ileś tam milisekund
    MMOD_HIVOLTAGE, // napięcie, odczyt co ileś tam milisekund
    MMOD_PRESET,    // ustaw napięcie PRESET
    MMOD_PRECIZE,    // reguluj napięcie PRESET
    MMOD_PREFS, // ustawianie preferencji mowy
    MMOD_WIFI,  // aktualne adresy IP
    MMOD_CALIB, // kalibracja
    MMOD_MAX
    };

    
struct WiFiPrefs {
    char password[32];
    char ssid[32];
    uint32_t ipadr;
    uint32_t gateway;
    uint32_t mask;
    int speechd_port;
    uint32_t speechd_addr;
    char module[32];
    char voice[32];
    int rate;
    int app_port;
    uint32_t app_addr;
    int app_burst;
    int raw_port;
    uint32_t raw_addr;
    int raw_burst;
    };

extern struct WiFiPrefs wiprefs;
extern void storeWiprefs(void);

extern int8_t mainMode, selShow;


extern void formatOhm(int value,char *buf, char *spk);
extern void formatVolt(int milivolt, char *buf, char *spk);

enum {
    DPMOD_SELECT = 0,
    DPMOD_NONE,
    DPMOD_VALUE,
    DPMOD_ZWARCIE,
    DPMOD_PRZERWA,
    DPMOD_SPEECH,
    DPMOD_WIFI,
    DPMOD_CALIB
    };

extern void AP_Start(void);
extern void AP_Stop(void);
extern void WiFi_Start(void);
extern void WiFi_Stop(void);

extern void sendUDPBuf(uint32_t addr, int port, const char *str);

#define int2ip(a) ((a)>>0) & 255, ((a)>>8) & 255, ((a)>>16) & 255, ((a)>>24) & 255

enum {
    CLB_VHI=0,
    CLB_VLO,
    CLB_UAC,
    CLB_VCC,
    CLB_DIO,
    CLB_SHO,
    CLB_R0,
    CLB_R1,
    CLB_R2,
    CLB_R3,
    CLB_R4,
    CLB_MAX
    };
extern int8_t thisCalib, oldCalib;
extern bool apActive;
#endif


