#include <stdio.h>
#include <string.h>


static int potocznie(int units, int cents, char *spk)
{
    //printf("U=%d, C=%d\n", units, cents);
    if (!cents) {
        sprintf(spk, "%d ", units);
        if (units == 1) return 0;
        if (units > 10 && units < 20) return 2;
        units %= 10;
        if (units >= 2 && units <= 4) return 1;
        return 2;
    }
    if (cents == 50) {
        if (!units) {
            strcpy(spk,"pół ");
        }
        else if (units == 1) {
            strcpy(spk,"półtora ");
        }
        else {
            sprintf(spk,"%d i pół", units);
        }
        return 3;
    }
    if (!(cents % 10)) {
        if (units > 10 && !(units & 10)) {
            sprintf(spk, "%d i %d ", units, cents / 10);
        }
        else sprintf(spk, "%d %d ", units, cents / 10);
        return 3;
    }
    sprintf(spk, "%d %d ", units, cents);
    return 3;
}

void formatOhm(int value,char *buf, char *spk)
{
    static const char *omy[] = {"om", "omy", "omów","oma"};
    static const char *units[]={"\177","k\177","M\177"};
    int shift = 0, va, vb;
    while (value >= 1000) {
        value = value / 10;
        shift += 1;
    }
    const char *unit=units[(shift+2) / 3];
    shift %= 3;
    if (shift == 1) sprintf(buf,"%d.%02d %s", va=value/100, vb=value % 100,unit);
    else if (shift == 2) {
        sprintf(buf,"%2d.%d %s", va=value/10, value % 10,unit);
        vb=10 * (value % 10);
    }
    else {
        sprintf(buf,"%4d %s", va=value,unit);
        vb=0;
    }
    int form = potocznie(va, vb, spk);
    if (*unit == 'k') strcat(spk, "kilo");
    else if (*unit == 'M') strcat(spk, "mega");
    else strcat(spk, omy[form]);
}


void formatVolt(int milivolt, char *buf, char *spk)
{
    static const char *volty[] = {"wolt", "wolty", "wolt","wolta"};
    char sgn = ' ';
    int centivolt = milivolt / 10;
    if (centivolt < 0) {
        sgn='-';
        centivolt = - centivolt;
    }
    //printf("VIN %d\n", centivolt);
    int va = centivolt / 100;
    int vb = centivolt % 100;
    //printf("VA %d, VB %d\n", va, vb);
    if (centivolt < 1000) {
        sprintf(buf,"%c%d.%02d V", sgn, va, vb);
    }
    else {
        vb -= vb % 10;
        sprintf(buf,"%c%2d.%d V", sgn, va, vb  / 10);
    }
    //printf("BUF %s\n", buf);
    if (sgn == '-') {
        strcpy(spk, "minus ");
        spk += 6;
    }
    int form = potocznie(va, vb, spk);
    strcat(spk, volty[form]);
}
