#!/usr/bin/env python
#coding: utf-8

import math, sys


ams0=[[10,93],[19.5,160],[30,222],[47,317],[67,414],[98,553],[120,632],[147,744]]
ams1=[[147,771],[217,1098],[380,1607]]
ams2=[[380,467],[466,544],[681,714],[977,908],[1480,1168],[2130,1419],[3250,1725]]
ams3=[[3250,622],[4690,811],[6830,1046],[9780,1292],[14900,1588],[21500,1896]]
ams4=[[21500,637],[31800,846],[46800,1106],[68400,1391],[98400,1665],[145200,1992],
    [198600,2248],[298000,2535],[477000,2787],[574000,2865],[670000,2920],[770000,2964],[949000,3020],
    [1046000,3048],[1145000,3070]]

ams=[ams4,ams3,ams2,ams1,ams0]
lranges=[627,612,457,760,80]#[80,760,457,612,627]
uranges=[3075,1916,1745,1640,764]#][764,1640,1745,1916,3075]

def ohmy(U,R,u):
    return u * R/(U-u)

def resolv(U1, R1, U2, R2):
    U1=float(U1)
    U2=float(U2)
    R1=float(R1)
    R2=float(R2)
    
    R = (U2 - U1) * R2 * R1 / (U1 * R2 - U2 * R1)
    Uz = U1 * (R1+R) / R1

    return (R, Uz)

def ohmset(nr):
    am = ams[nr]
    sout=[]
    for i in range(len(am)-1,0,-1):
        p1 = am[i-1]
        p2 = am[i]
        a1 = lranges[nr] if i == 1 else p1[1]
        a2 = uranges[nr] if i == len(am) - 1 else p2[1]
        r, u = resolv(p2[1],p2[0],p1[1],p1[0])
        o = ohmy(u,r,p1[1])
        sout.append("{%d, %d, %.2f, %.2f}" % (a1,a2,u,r))
    st="    {%d, %d, %d, {\n        %s}\n    }" % \
        (len(am)-1,lranges[nr],uranges[nr],',\n        '.join(sout))
    return st


nrans = max(len(a) for a in ams)
st=list(ohmset(i) for i in range(len(ams)))
rst = """/* Plik wygenerowany automatycznie
 * programem %s!
 * Nie edytuj ręcznie, i tak zostanie nadpisany
 */
#ifndef OHMSET_H
#define OHMSET_H 1
#define OHMSETCNT %d
static struct ohmset {
    int nranges;
    int umin;
    int umax;
    struct {
        int lora;
        int hira;
        double U;
        double R;
    } ranges[%d];
} ohmsets[OHMSETCNT]={\n%s\n};
#endif
""" % ((sys.argv[0],len(ams), nrans-1,",\n".join(st)))

open('ohmset.h','w').write(rst)
